package net.wanji.common.enums;

/**
 * @author Kent HAN
 * @date 2022/11/8 17:20
 */
public enum AreaEnum {

    // 区划类型：1行政区划；2交警辖区；3商圈；4交通小区；5热点区域；6道路
    ADMIN(1, "行政区划"),
    POLICE(2, "交警辖区"),
    BUSSINESS(3, "商圈"),
    TRANSPORT(4, "交通小区"),
    HOTSPOT(5, "热点区域"),
    ROAD(6, "道路");

    private final int code;
    private final String msg;

    AreaEnum(int code, String msg) {
        this.code = code;
        this.msg = msg;
    }

    public static String getMsgByCode(int code) {
        for (AreaEnum value : AreaEnum.values()) {
            if (value.code == code) {
                return value.msg;
            }
        }
        return null;
    }

    public String getMsg() {
        return msg;
    }

    public Integer getCode() {
        return code;
    }
}
