package net.wanji.common.enums;

/**
 * @author Kent HAN
 * @date 2022/11/8 17:20
 */
public enum CrossInOutEnum {
    IN(1, "进口"),
    OUT(2, "出口");

    private final int code;
    private final String msg;

    CrossInOutEnum(int code, String msg) {
        this.code = code;
        this.msg = msg;
    }

    public static String getMsgByCode(int code) {
        for (CrossInOutEnum value : CrossInOutEnum.values()) {
            if (value.code == code) {
                return value.msg;
            }
        }
        return null;
    }

    public String getMsg() {
        return msg;
    }

    public Integer getCode() {
        return code;
    }
}
