package net.wanji.common.framework.spring;

import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.stereotype.Component;

import java.util.Map;

/**
 * @author wanji
 */
@Component
public class ServiceBeanContext implements ApplicationContextAware {

    private static volatile ApplicationContext ctx = null;


    private ServiceBeanContext() {
    }

    public static void loadContext(ApplicationContext context) {
        ctx = context;
    }

    public static ApplicationContext getContext() {
        return ctx;
    }

    public static <T> T getBean(String name) {
        return (T) ctx.getBean(name);
    }

    public static <T> T getBean(Class<T> clazz) {
        return ctx.getBean(clazz);
    }

    public static <T> Map<String, T> getInterfaceBeanMap(Class<T> clazz) {
        return ctx.getBeansOfType(clazz);
    }

    @Override
    public void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
        ctx = applicationContext;
    }
}
