package net.wanji.common.gts.service;

public interface GtsService {

	/**
	 * acoor和bcoor的交集
	 * @param acoor
	 * @param bcoor
	 * @return 交集坐标对
	 * @throws Exception
	 */
	public String intersection(String acoor, String bcoor) throws Exception;

	/**
	 *  acoor和bcoor的并集
	 * @param acoor
	 * @param bcoor
	 * @return 并集坐标对
	 */
	public String union(String acoor, String bcoor);

	/**
	 * 获取coor的指定distance距离的缓冲区
	 * @param coor  
	 * @param distance
	 * @return 缓冲区坐标对
	 */
	public String buffer(String coor, double distance);

	/**
	 * acoor是否包含bcoor
	 * @param acoor
	 * @param bcoor
	 * @return
	 */
	public boolean contains(String acoor, String bcoor);

	/**
	 *  acoor与bcoor是否相交
	 * @param acoor
	 * @param bcoor
	 * @return
	 */
	public boolean intersects(String acoor, String bcoor);

	/**
	 * 获取acoor与bcoor的差异
	 * @param acoor
	 * @param bcoor
	 * @return 差异集合点集
	 */
	public String different(String acoor, String bcoor);

	/**
	 * 对称差异分析
	 * @param acoor
	 * @param bcoor
	 * @return 对称差异坐标对。多区域用#分割
	 */
	public String symDifferent(String acoor, String bcoor);

	/**
	 * 获取acoor和bcoor的距离
	 * @param acoor
	 * @param bcoor
	 * @return 距离
	 */
	public double distance(String acoor, String bcoor);

	/**
	 * 计算多边形面积
	 * @param coor
	 * @return 多边形面积
	 */
	public double polygonarea(String coor);

	/**
	 * 获取中心点
	 * @param coor
	 * @return 中心点坐标
	 */
	public String centroid(String coor);

	/**
	 * 获取外接多边形
	 * @param coor
	 * @return
	 */
	public String bounds(String coor);
}
