package net.wanji.common.gts.service.impl;

import net.wanji.common.gts.GeometryUtil;
import net.wanji.common.gts.Tools;
import net.wanji.common.gts.service.GtsService;
import org.locationtech.jts.geom.Coordinate;
import org.locationtech.jts.geom.Geometry;
import org.locationtech.jts.geom.Point;
import org.springframework.stereotype.Service;
@Service
public class GtsServiceImpl implements GtsService {

	@Override
	public String intersection(String acoor, String bcoor) throws Exception {
		 
		Geometry geometryA = GeometryUtil.str2Geometry(acoor);
		Geometry geometryb = GeometryUtil.str2Geometry(bcoor);
		if (geometryA == null || geometryb == null) {
			return null;
		} else {
			Geometry intersections = geometryA.intersection(geometryb);
			 
			int num = intersections.getNumGeometries();
			StringBuffer sb = new StringBuffer();
			Geometry temp = null;
			Coordinate[] coors = null;
			for (int i = 0; i < num; i++) {
				temp = intersections.getGeometryN(i);
				coors = temp.getCoordinates();
				for (int j = 0; j < coors.length; j++) {
					if (j == coors.length - 1) {
						sb.append(Tools.getNumberFormatString(coors[j].x, 6, 6) + "," + Tools.getNumberFormatString(coors[j].y,6, 6));
					} else {
						sb.append(Tools.getNumberFormatString(coors[j].x, 6, 6) + "," + Tools.getNumberFormatString(coors[j].y,6, 6)+";");
					}
				}
				sb.append("#");
			}
			return sb.substring(0, sb.length() - 1);
		} 
	}

	@Override
	public String union(String acoor, String bcoor) { 
		Geometry geometryA = GeometryUtil.str2Geometry(acoor);
		Geometry geometryb = GeometryUtil.str2Geometry(bcoor);
		if (geometryA == null || geometryb == null) { 
			return null;
		} else {
			Geometry intersections = geometryA.union(geometryb); 
			int num = intersections.getNumGeometries();
			StringBuffer sb = new StringBuffer();
			Geometry temp = null;
			Coordinate[] coors = null;
			for (int i = 0; i < num; i++) {
				temp = intersections.getGeometryN(i);
				coors = temp.getCoordinates();
				for (int j = 0; j < coors.length; j++) {
					if (j == coors.length - 1) {
						sb.append(Tools.getNumberFormatString(coors[j].x, 6, 6) + "," + Tools.getNumberFormatString(coors[j].y,6, 6));
					} else {
						sb.append(Tools.getNumberFormatString(coors[j].x, 6, 6) + "," + Tools.getNumberFormatString(coors[j].y,6, 6)+";");
					}
				}
				sb.append("#");
			}
//			bean.setResult(sb.substring(0, sb.length() - 1));
			return sb.substring(0, sb.length() - 1);
		}
		
	}

	@Override
	public String buffer(String coor, double distance) {
//		ResultBean<String> bean = new ResultBean<String>();
		Geometry geometry = GeometryUtil.str2Geometry(coor);
		
		if (geometry == null ) {
			return null;
//			bean.setSuccessful(false);
//			bean.setInfo("坐标格式错误");
		} else {
			Geometry intersections = geometry.buffer(distance/111.12);
//			bean.setSuccessful(true);
			int num = intersections.getNumGeometries();
			StringBuffer sb = new StringBuffer();
			Geometry temp = null;
			Coordinate[] coors = null;
			for (int i = 0; i < num; i++) {
				temp = intersections.getGeometryN(i);
				coors = temp.getCoordinates();
				for (int j = 0; j < coors.length; j++) {
					if (j == coors.length - 1) {
						sb.append(Tools.getNumberFormatString(coors[j].x, 6, 6) + "," + Tools.getNumberFormatString(coors[j].y,6, 6));
					} else {
						sb.append(Tools.getNumberFormatString(coors[j].x, 6, 6) + "," + Tools.getNumberFormatString(coors[j].y,6, 6)+";");
					}
				}
				sb.append("#");
			}
			if (num != 0) {
			return sb.substring(0, sb.length() - 1);
			}
		}
		return null;
	}

	@Override
	public boolean contains(String acoor, String bcoor) { 
		Geometry geometryA = GeometryUtil.str2Geometry(acoor);
		Geometry geometryb = GeometryUtil.str2Geometry(bcoor);
		if (geometryA == null || geometryb == null) {
			return false;
		} else {
			Boolean contains = geometryA.contains(geometryb);
			return contains;
		}
//		return bean;
	}

	@Override
	public boolean intersects(String acoor, String bcoor) {
//		ResultBean<String> bean = new ResultBean<String>();
		Geometry geometryA = GeometryUtil.str2Geometry(acoor);
		Geometry geometryb = GeometryUtil.str2Geometry(bcoor);
		if (geometryA == null || geometryb == null) {
//			bean.setSuccessful(false);
//			bean.setInfo("坐标格式错误");
			return false;
		} else {
			Boolean contains = geometryA.intersects(geometryb);
//			bean.setSuccessful(true);
//			bean.setResult(contains+"");
			return contains;
		}
//		return bean;
	}

	@Override
	public String different(String acoor, String bcoor) {
//		ResultBean<String> bean = new ResultBean<String>();
		Geometry geometryA = GeometryUtil.str2Geometry(acoor);
		Geometry geometryb = GeometryUtil.str2Geometry(bcoor);
		if (geometryA == null || geometryb == null) {
//			bean.setSuccessful(false);
//			bean.setInfo("坐标格式错误");
			return null;
		} else {
			Geometry intersections = geometryA.difference(geometryb);
//			bean.setSuccessful(true);
			int num = intersections.getNumGeometries();
			StringBuffer sb = new StringBuffer();
			Geometry temp = null;
			Coordinate[] coors = null;
			for (int i = 0; i < num; i++) {
				temp = intersections.getGeometryN(i);
				coors = temp.getCoordinates();
				for (int j = 0; j < coors.length; j++) {
					if (j == coors.length - 1) {
						sb.append(Tools.getNumberFormatString(coors[j].x, 6, 6) + "," + Tools.getNumberFormatString(coors[j].y,6, 6));
					} else {
						sb.append(Tools.getNumberFormatString(coors[j].x, 6, 6) + "," + Tools.getNumberFormatString(coors[j].y,6, 6)+";");
					}
				}
				sb.append("#");
			}
			return sb.substring(0, sb.length() - 1);
		}
//		return bean;
	}

	@Override
	public String symDifferent(String acoor, String bcoor) {
//		ResultBean<String> bean = new ResultBean<String>();
		Geometry geometryA = GeometryUtil.str2Geometry(acoor);
		Geometry geometryb = GeometryUtil.str2Geometry(bcoor);
		if (geometryA == null || geometryb == null) {
//			bean.setSuccessful(false);
//			bean.setInfo("坐标格式错误");
			return null;
		} else {
			Geometry intersections = geometryA.symDifference(geometryb);
//			bean.setSuccessful(true);
			int num = intersections.getNumGeometries();
			StringBuffer sb = new StringBuffer();
			Geometry temp = null;
			Coordinate[] coors = null;
			for (int i = 0; i < num; i++) {
				temp = intersections.getGeometryN(i);
				coors = temp.getCoordinates();
				for (int j = 0; j < coors.length; j++) {
					if (j == coors.length - 1) {
						sb.append(Tools.getNumberFormatString(coors[j].x, 6, 6) + "," + Tools.getNumberFormatString(coors[j].y,6, 6));
					} else {
						sb.append(Tools.getNumberFormatString(coors[j].x, 6, 6) + "," + Tools.getNumberFormatString(coors[j].y,6, 6)+";");
					}
				}
				sb.append("#");
			}
			return sb.substring(0, sb.length() - 1);
		}
//		return bean;
	}

	@Override
	public double distance(String acoor, String bcoor) {
//		ResultBean<String> bean = new ResultBean<String>();
		Geometry geometryA = GeometryUtil.str2Geometry(acoor);
		Geometry geometryb = GeometryUtil.str2Geometry(bcoor);
		if (geometryA == null || geometryb == null) {
//			bean.setSuccessful(false);
//			bean.setInfo("坐标格式错误");
			return -1;
		} else {
			double distance = geometryA.distance(geometryb)* 111.12 ;//不知道为什么要乘以111.12（一度是约111.12公里）
//			bean.setSuccessful(true);
//			bean.setResult(distance);
			return distance;
		}
//		return bean;
	}

	@Override
	public double polygonarea(String coor) {
//		ResultBean<String> bean = new ResultBean<String>();
		Geometry geometry = GeometryUtil.str2Geometry(coor);
		if (geometry == null) {
//			bean.setSuccessful(false);
//			bean.setInfo("坐标格式错误");
			return -1;
		} else {
			double area = geometry.getArea()*10000 ;//不知道为什么要这样计算（可能一度=60海里 1海里=1852km）
//			bean.setSuccessful(true);
//			bean.setResult(area);
			return area;
		}
//		return bean;
	}

	@Override
	public String centroid(String coor) {
//		ResultBean<String> bean = new ResultBean<String>();
		Geometry geometry = GeometryUtil.str2Geometry(coor);
		if (geometry == null) {
//			bean.setSuccessful(false);
//			bean.setInfo("坐标格式错误");
			return null;
		} else {
			Point point = geometry.getCentroid();
			return Tools.getNumberFormatString(point.getX(), 6, 6) + "," + Tools.getNumberFormatString(point.getY(),6, 6);
		}
//		return bean;
	}
	
	@Override
	public String bounds(String coor) {
//		ResultBean<String> bean = new ResultBean<String>();
		Geometry geometry = GeometryUtil.str2Geometry(coor);
		if (geometry == null) {
//			bean.setSuccessful(false);
//			bean.setInfo("坐标格式错误");
			return null;
		} else {
			Geometry boundGeom = geometry.getBoundary();
//			bean.setSuccessful(true);
			int num = boundGeom.getNumGeometries();
			StringBuffer sb = new StringBuffer();
			Geometry temp = null;
			Coordinate[] coors = null;
			for (int i = 0; i < num; i++) {
				temp = boundGeom.getGeometryN(i);
				coors = temp.getCoordinates();
				for (int j = 0; j < coors.length; j++) {
					if (j == coors.length - 1) {
						sb.append(Tools.getNumberFormatString(coors[j].x, 6, 6) + "," + Tools.getNumberFormatString(coors[j].y,6, 6));
					} else {
						sb.append(Tools.getNumberFormatString(coors[j].x, 6, 6) + "," + Tools.getNumberFormatString(coors[j].y,6, 6)+";");
					}
				}
				sb.append("#");
			}
			return sb.substring(0, sb.length() - 1);		
			}
//		return bean;
	}

}
